Subject: Re: 29.0.60; Tree-sitter user-level control

From: Eli Zaretskii <[email-masked]>
Date: Sat, 21 Jan 2023 14:36:00 +0200

> From: Theodor Thornhill <[email-masked]>
> Cc: Yuan Fu <[email-masked]>
> Date: Sat, 21 Jan 2023 12:48:58 +0100
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >  . How does one change the indentation style in c-ts-mode?
> >
> >    - There is a defcustom c-ts-mode-indent-style, but I don't think I
> >      see any difference in indentation of new code when I change the
> >      value.  What am I missing?
> >
> 
> (setq c-ts-mode-indent-style 'bsd) then revert-buffer fixes it for me.
> It seems you need to reload the file to enable the new style.  Should I
> add a command that can be set explicitly as in c-mode?
> 'c-ts-mode-set-style'?

I think we need both a command and a :set function for the defcustom.

> However, going over it I see there are lots of regressions after the new
> bracket-counting code added recently, effectively making the indent
> styles pretty broken right now...

That's a separate issue, and I'm sure it will be fixed.  And adding
tests to the test suite will prevent us from breaking it too easily in
the future.

> >  . What commands are affected by treesit-defun-tactic?
> 
> 'treesit--navigate-thing' uses it, so 'beginning-of-defun',
> 'forward-sentence' etc uses it through 'treesit-beginning-of-thing'.

What commands except those that call treesit--navigate-thing call
beginning-of-defun and treesit-beginning-of-thing?